// Copyright (c) 2021 NetEase, Inc.  All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

#include "FLTService.h"
#include "FLTConvert.h"

std::string FLTService::getServiceName() const {
    return m_serviceName;
}

void FLTService::notifyEvent(const std::string& eventName, flutter::EncodableMap& arguments) {
    arguments.insert(std::make_pair(flutter::EncodableValue("serviceName"), flutter::EncodableValue(m_serviceName)));
    YXLOG_API(Info) << "serviceName: " << m_serviceName << ", eventName: " << eventName
                    << ", arguments: " << Convert::getInstance()->getStringFormMapForLog(&arguments) << YXLOGEnd;
    NimCore::getInstance()->invokeMethod(eventName, arguments);
}

void FLTService::notifyEventEx(const std::string& serviceName, const std::string& eventName, flutter::EncodableMap& arguments) {
    arguments.insert(std::make_pair(flutter::EncodableValue("serviceName"), flutter::EncodableValue(serviceName)));
    YXLOG_API(Info) << "serviceName: " << serviceName << ", eventName: " << eventName
                    << ", arguments: " << Convert::getInstance()->getStringFormMapForLog(&arguments) << YXLOGEnd;
    NimCore::getInstance()->invokeMethod(eventName, arguments);
}
